#!/usr/bin/perl

use warnings;
use strict;

my $fname;
my $fext;
my $inputfile = shift @ARGV;
if ($inputfile =~ /(\w+)\.(c|cc|cpp)$/) { # matches c,cc,cpp extensions
    $inputfile = $&; # whole match ie... myfile.c
    $fname = $1;     # matches 1st group (\w+) = myfile
    $fext = $2;      # matches 2nd group (c|cc|cpp) = c
}

# command line options should be modified as needed...
# with an input of myfile.c, the following command lines
# expand as follows...

#  $compiler = "/usr/local/propeller/bin/propeller-elf-gcc myfile.c   -o myfile.x"
my $compiler = "/usr/local/propeller/bin/propeller-elf-gcc $inputfile -o $fname.x";

#  $loader   = "/usr/local/propeller/bin/propeller-load -r myfile.x"
my $loader   = "/usr/local/propeller/bin/propeller-load -r $fname.x";

# run compiler, die on compile errors...
my $rc = system ("$compiler");
die "\nsystem($compiler) failed with status $rc" unless $rc == 0;

# run loader, die on load errors...
$rc = system ("$loader");
die "\nsystem($loader) failed with status $rc" unless $rc == 0;

print "\ncompile & load was a success...";

__END__